## highwayhash 0~20180209

=== Makefile ===
# We assume X64 unless HH_POWER or HH_AARCH64 are defined.

override CPPFLAGS += -I.
override CXXFLAGS += -std=c++11 -Wall -O3 -fPIC -pthread
override LDFLAGS += -pthread

SIP_OBJS := $(addprefix obj/, \
	sip_hash.o \
	sip_tree_hash.o \
	scalar_sip_tree_hash.o \
)

DISPATCHER_OBJS := $(addprefix obj/, \
	arch_specific.o \
	instruction_sets.o \
	nanobenchmark.o \
	os_specific.o \
)

HIGHWAYHASH_OBJS := $(DISPATCHER_OBJS) obj/hh_portable.o
HIGHWAYHASH_TEST_OBJS := $(DISPATCHER_OBJS) obj/highwayhash_test_portable.o
VECTOR_TEST_OBJS := $(DISPATCHER_OBJS) obj/vector_test_portable.o

ifdef HH_AARCH64
HH_X64 =
else
ifdef HH_POWER
HH_X64 =
HIGHWAYHASH_OBJS += obj/hh_vsx.o
HIGHWAYHASH_TEST_OBJS += obj/highwayhash_test_vsx.o
else
HH_X64 = 1
HIGHWAYHASH_OBJS += obj/hh_avx2.o obj/hh_sse41.o
HIGHWAYHASH_TEST_OBJS += obj/highwayhash_test_avx2.o obj/highwayhash_test_sse41.o
VECTOR_TEST_OBJS += obj/vector_test_avx2.o obj/vector_test_sse41.o
endif
endif

all: $(addprefix bin/, \
	profiler_example nanobenchmark_example vector_test sip_hash_test \
	highwayhash_test benchmark) lib/libhighwayhash.a

obj/%.o: highwayhash/%.cc
	@mkdir -p -- $(dir $@)
	$(CXX) -c $(CPPFLAGS) $(CXXFLAGS) $< -o $@

bin/%: obj/%.o
	@mkdir -p -- $(dir $@)
	$(CXX) $(LDFLAGS) $^ -o $@

.DELETE_ON_ERROR:
deps.mk: $(wildcard highwayhash/*.cc) $(wildcard highwayhash/*.h) Makefile
	set -eu; for file in highwayhash/*.cc; do \
		target=obj/$${file##*/}; target=$${target%.*}.o; \
		[ "$$target" = "obj/highwayhash_target.o" ] || \
		[ "$$target" = "obj/data_parallel_benchmark.o" ] || \
		[ "$$target" = "obj/data_parallel_test.o" ] || \
		$(CXX) -c $(CPPFLAGS) $(CXXFLAGS) -DHH_DISABLE_TARGET_SPECIFIC -MM -MT \
		"$$target" "$$file"; \
	done | sed -e ':b' -e 's-../[^./]*/--' -e 'tb' >$@
-include deps.mk

bin/profiler_example: $(DISPATCHER_OBJS)

bin/nanobenchmark_example: $(DISPATCHER_OBJS) obj/nanobenchmark.o

ifdef HH_X64
obj/sip_tree_hash.o: CXXFLAGS+=-mavx2
# (Compiled from same source file with different compiler flags)
obj/highwayhash_test_avx2.o: CXXFLAGS+=-mavx2
obj/highwayhash_test_sse41.o: CXXFLAGS+=-msse4.1
obj/hh_avx2.o: CXXFLAGS+=-mavx2
obj/hh_sse41.o: CXXFLAGS+=-msse4.1
obj/vector_test_avx2.o: CXXFLAGS+=-mavx2
obj/vector_test_sse41.o: CXXFLAGS+=-msse4.1

obj/benchmark.o: CXXFLAGS+=-mavx2
endif

ifdef HH_POWER
obj/highwayhash_test_vsx.o: CXXFLAGS+=-mvsx
obj/hh_vsx.o: CXXFLAGS+=-mvsx
obj/benchmark.o: CXXFLAGS+=-mvsx
# Skip file - vector library/test not supported on PPC
obj/vector_test_target.o: CXXFLAGS+=-DHH_DISABLE_TARGET_SPECIFIC
obj/vector_test.o: CXXFLAGS+=-DHH_DISABLE_TARGET_SPECIFIC
endif

lib/libhighwayhash.a: $(SIP_OBJS) $(HIGHWAYHASH_OBJS) obj/c_bindings.o
	@mkdir -p -- $(dir $@)
	$(AR) rcs $@ $^
	# Disabled due to false positives; ideally the test instead ensures
	# target-specific modules _only_ export symbols starting with a prefix.
	# ./test_exports.sh $^

lib/libhighwayhash.so: $(SIP_OBJS) $(HIGHWAYHASH_OBJS) obj/c_bindings.o
	@mkdir -p -- $(dir $@)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -shared $^ -o $@.0 -Wl,-soname,libhighwayhash.so.0
	@cd $(dir $@); ln -s libhighwayhash.so.0 libhighwayhash.so

bin/highwayhash_test: $(HIGHWAYHASH_TEST_OBJS)

bin/benchmark: obj/benchmark.o $(HIGHWAYHASH_TEST_OBJS)
bin/benchmark: $(SIP_OBJS) $(HIGHWAYHASH_OBJS)
bin/vector_test: $(VECTOR_TEST_OBJS)

clean:
	[ ! -d obj ] || $(RM) -r -- obj/

distclean: clean
	[ ! -d bin ] || $(RM) -r -- bin/
	[ ! -d lib ] || $(RM) -r -- lib/

# Mode bits are from issue #58, thanks to yurivict for suggesting.
install: lib/libhighwayhash.a lib/libhighwayhash.so
	mkdir -p $(DESTDIR)/$(LIBDIR)
	mkdir -p $(DESTDIR)/$(INCDIR)/highwayhash
	install -m0444 lib/libhighwayhash.a $(DESTDIR)/$(LIBDIR)
	install -m0555 lib/libhighwayhash.so $(DESTDIR)/$(LIBDIR)
	install -m0444 highwayhash/*.h $(DESTDIR)/$(INCDIR)/highwayhash/

.PHONY: clean distclean all install

## highwayhash 0~20180209-g14dedec

=== debian/changelog ===
highwayhash (0~20180209-g14dedec-5) unstable; urgency=medium

  * Refresh symbols to avoid FTBFS with GCC-8 (Closes: #897767)
  * Bump Standards-Version to 4.1.5 (no change).

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 22 Jul 2018 02:52:36 +0000

highwayhash (0~20180209-g14dedec-4) unstable; urgency=medium

  * Depending on build-essential to really fix autopkgtest failure.
  * Add watch file to monitor upstream git HEAD.
  * Don't override debian-watch-file-is-missing, already fixed.
  * Bump Standards-Version to 4.1.4 (no change).

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 28 Jun 2018 05:16:34 +0000

highwayhash (0~20180209-g14dedec-3) unstable; urgency=medium

  * Set Ccience team as the maintainer
    + Put myself to Uploaders.
  * Move the packaging repo to salsa science team's namespace
    + Update Vcs-* links in control.
  * Add gcc to autopkgtest depends to fix CI test failure.
  * Collect symbol updates for x32 from buildd.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 03 Apr 2018 16:07:22 +0000

highwayhash (0~20180209-g14dedec-2) unstable; urgency=medium

  * Remove ppc64 from Architecture list as suggested by upstream.
    + https://github.com/google/highwayhash/issues/66
    - Remove ppc64 symbols.
  * Collect symbols update from buildd for arm64 and ppc64el.
  * Upload to unstable.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 27 Mar 2018 09:04:28 +0000

highwayhash (0~20180209-g14dedec-1) experimental; urgency=medium

  * New upstream snapshot 0~20180209-g14dedec
  * Remove all patches since are included in this snapshot.
  * Refresh symbols for amd64.
  * Remove debian/highwayhash.3 which was already merged in upstream source.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 25 Mar 2018 08:39:28 +0000

highwayhash (0~20180103-geeea446-2) experimental; urgency=medium

  * Cherry-pick upstream fix for ppc64.
    + up_add_file_update_makefile_for_ppc64_vsx.patch
  * Collect symbols update for arm64 and x32 from buildd.
    Refresh symbols for amd64. (Closes: #877130)
  * Don't build anymore on architectures that are not supported by upstream.
  * Check DEB_BUILD_PROFILES on the overriden dh_auto_test target.
  * Fix package-uses-deprecated-source-override-location.
  * Override symbols-file-contains-debian-revision which is a false-positive.

 -- Mo Zhou <cdluminate@gmail.com>  Wed, 07 Feb 2018 04:25:14 +0000

highwayhash (0~20180103-geeea446-1) experimental; urgency=medium

  * Import upstream snapshot eeea4463df1639c7ce271a1d0fdfa8ae5e81a49f .
  * Remove all patches because they were merged by upstream.
    - makefile-disable-siptreehash-and-make-solib.patch
    - makefile-target-install.patch
  * compat: Bump debhelper compat to 11
  * control: Add new B-D "rename" and Vcs-* fields
  * control: Add missing depends to dev package (Closes: #877207)
  * control: Bump Standards-Version to 4.1.3 (no change)
  * copyright: fix insecure-copyright-format-uri
  * rules: fix build and installation.
  * Symbols: refresh. (Closes: #877130)
  * Update my name.

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 18 Jan 2018 10:07:06 +0000

highwayhash (0~20170419-g1f4a24f-2) experimental; urgency=medium

  * Collect symbols patch from buildd for arm64, ppc64, ppc64el and x32.
  * Make SYNOPSIS section of highwayhash.3 less ambiguous.
  * Rules: trivial update.

 -- Zhou Mo <cdluminate@gmail.com>  Thu, 27 Apr 2017 02:15:24 +0000

highwayhash (0~20170419-g1f4a24f-1) experimental; urgency=medium

  * Initial release. (Closes: #848885)

 -- Zhou Mo <cdluminate@gmail.com>  Tue, 25 Apr 2017 04:13:09 +0000

=== debian/control ===
Source: highwayhash
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <cdluminate@gmail.com>
Build-Depends: debhelper (>= 11), rename
Standards-Version: 4.1.5
Homepage: https://github.com/google/highwayhash
Vcs-Git: https://salsa.debian.org/science-team/highwayhash.git
vcs-Browser: https://salsa.debian.org/science-team/highwayhash

Package: libhighwayhash-dev
Section: libdevel
Architecture: amd64 arm64 x32 ppc64el
Depends: ${misc:Depends}, ${shlibs:Depends},
         libhighwayhash0 (= ${binary:Version})
Description: Fast strong hash functions: SipHash/HighwayHash (development)
 Highwayhash provides three 'strong' (well-distributed and unpredictable)
 hash functions: a faster version of SipHash, a data-parallel variant of
 SipHash using tree hashing, and an even faster algorithm called HighwayHash.
 .
 SipHash is a fast but 'cryptographically strong' pseudo-random function by
 Aumasson and Bernstein [https://www.131002.net/siphash/siphash.pdf].
 .
 SipTreeHash slices inputs into 8-byte packets and computes their SipHash in
 parallel, which is faster when processing at least 96 bytes.
 .
 HighwayHash is a new way of mixing inputs which may inspire new
 cryptographically strong hashes. Large inputs are processed at a rate of
 0.3 cycles per byte, and latency remains low even for small inputs.
 HighwayHash is faster than SipHash for all input sizes, with about 3.8 times
 higher throughput at 1 KiB.
 .
 This package ships the static library and development files.

Package: libhighwayhash0
Section: libs
Architecture: amd64 arm64 x32 ppc64el
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Fast strong hash functions: SipHash/HighwayHash (library)
 Highwayhash provides three 'strong' (well-distributed and unpredictable)
 hash functions: a faster version of SipHash, a data-parallel variant of
 SipHash using tree hashing, and an even faster algorithm called HighwayHash.
 .
 SipHash is a fast but 'cryptographically strong' pseudo-random function by
 Aumasson and Bernstein [https://www.131002.net/siphash/siphash.pdf].
 .
 SipTreeHash slices inputs into 8-byte packets and computes their SipHash in
 parallel, which is faster when processing at least 96 bytes.
 .
 HighwayHash is a new way of mixing inputs which may inspire new
 cryptographically strong hashes. Large inputs are processed at a rate of
 0.3 cycles per byte, and latency remains low even for small inputs.
 HighwayHash is faster than SipHash for all input sizes, with about 3.8 times
 higher throughput at 1 KiB.
 .
 This package ships the shared object.

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=0~%cd-g%h" \
https://github.com/google/highwayhash \
HEAD debian uupdate

## highwayhash 0~git20181002.c5ee50b

=== Makefile ===
--- 
+++ 
@@ -3,6 +3,10 @@
 override CPPFLAGS += -I.
 override CXXFLAGS += -std=c++11 -Wall -O3 -fPIC -pthread
 override LDFLAGS += -pthread
+
+PREFIX ?= /usr/local
+INCDIR ?= $(PREFIX)/include
+LIBDIR ?= $(PREFIX)/lib
 
 SIP_OBJS := $(addprefix obj/, \
 	sip_hash.o \
@@ -35,6 +39,9 @@
 VECTOR_TEST_OBJS += obj/vector_test_avx2.o obj/vector_test_sse41.o
 endif
 endif
+
+# In case highwayhash_test defines PRINT_RESULTS.
+HIGHWAYHASH_TEST_OBJS += $(HIGHWAYHASH_OBJS)
 
 all: $(addprefix bin/, \
 	profiler_example nanobenchmark_example vector_test sip_hash_test \

=== debian/changelog ===
highwayhash (0~git20181002.c5ee50b-3) unstable; urgency=medium

  * Team upload
  * Really build on arch:any

 -- Aron Xu <aron@debian.org>  Mon, 26 Nov 2018 23:06:33 +0800

highwayhash (0~git20181002.c5ee50b-2) unstable; urgency=medium

  * Team upload
  * Build on arch:any

 -- Aron Xu <aron@debian.org>  Mon, 26 Nov 2018 22:37:21 +0800

highwayhash (0~git20181002.c5ee50b-1) unstable; urgency=medium

  * Change pretty format string in watch file.
  * New upstream version 0~git20181002.c5ee50b

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 25 Nov 2018 02:02:55 +0000

highwayhash (0~20180209-g14dedec-6) unstable; urgency=medium

  * Collect symbols update from buildd. (Closes: #897767)
    + Update symbols for arm64, ppc64el, x32 .
  * Bump Standards-Version to 4.2.0 (no change).

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 23 Aug 2018 05:47:28 +0000

## highwayhash 0~git20190222.276dd7b

=== debian/changelog ===
highwayhash (0~git20190222.276dd7b-1) unstable; urgency=medium

  * New upstream version 0~git20190222.276dd7b
  * Refresh symbols.

 -- Mo Zhou <cdluminate@gmail.com>  Sun, 24 Feb 2019 02:25:23 +0000

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Mo Zhou <cdluminate@gmail.com>
 Build-Depends: debhelper (>= 11), rename
-Standards-Version: 4.1.5
+Standards-Version: 4.2.0
 Homepage: https://github.com/google/highwayhash
 Vcs-Git: https://salsa.debian.org/science-team/highwayhash.git
 vcs-Browser: https://salsa.debian.org/science-team/highwayhash
 
 Package: libhighwayhash-dev
 Section: libdevel
-Architecture: amd64 arm64 x32 ppc64el
+Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends},
          libhighwayhash0 (= ${binary:Version})
 Description: Fast strong hash functions: SipHash/HighwayHash (development)
@@ -35,7 +35,7 @@
 
 Package: libhighwayhash0
 Section: libs
-Architecture: amd64 arm64 x32 ppc64el
+Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Fast strong hash functions: SipHash/HighwayHash (library)

## highwayhash 0~git20191002.0aaf66b

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# We assume X64 unless HH_POWER or HH_AARCH64 are defined.
+# We assume X64 unless HH_POWER, HH_ARM, or HH_AARCH64 are defined.
 
 override CPPFLAGS += -I.
 override CXXFLAGS += -std=c++11 -Wall -O3 -fPIC -pthread
@@ -25,8 +25,17 @@
 HIGHWAYHASH_TEST_OBJS := $(DISPATCHER_OBJS) obj/highwayhash_test_portable.o
 VECTOR_TEST_OBJS := $(DISPATCHER_OBJS) obj/vector_test_portable.o
 
+# aarch64 and ARM use the same code, although ARM usually needs an extra flag for NEON.
+ifdef HH_ARM
+CXXFLAGS += -mfloat-abi=hard -march=armv7-a -mfpu=neon
+HH_AARCH64 = 1
+endif
+
 ifdef HH_AARCH64
 HH_X64 =
+HIGHWAYHASH_OBJS += obj/hh_neon.o
+HIGHWAYHASH_TEST_OBJS += obj/highwayhash_test_neon.o
+VECTOR_TEST_OBJS += obj/vector_test_neon.o
 else
 ifdef HH_POWER
 HH_X64 =
@@ -72,6 +81,7 @@
 bin/nanobenchmark_example: $(DISPATCHER_OBJS) obj/nanobenchmark.o
 
 ifdef HH_X64
+# TODO: Portability: Have AVX2 be optional so benchmarking can be done on older machines.
 obj/sip_tree_hash.o: CXXFLAGS+=-mavx2
 # (Compiled from same source file with different compiler flags)
 obj/highwayhash_test_avx2.o: CXXFLAGS+=-mavx2

=== debian/changelog ===
highwayhash (0~git20191002.0aaf66b-1) unstable; urgency=medium

  * New upstream version 0~git20191002.0aaf66b
  * Collect symbols update from buildd for ppc64el.

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 04 Oct 2019 07:48:51 +0000

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

BUILD_ARCH=$(shell dpkg-architecture -qDEB_BUILD_ARCH)
MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DESTDIR=/usr
export LIBDIR=$(DESTDIR)/lib/$(MULTIARCH)/
export INCDIR=$(DESTDIR)/include/
TESTBINS = highwayhash_test nanobenchmark_example profiler_example sip_hash_test vector_test

ifeq (arm64,$(BUILD_ARCH))
export HH_AARCH64=1
endif
ifeq (ppc64,$(BUILD_ARCH))
export HH_POWER=1
endif
ifeq (ppc64el,$(BUILD_ARCH))
export HH_POWER=1
endif

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	-$(RM) deps.mk

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test
	for ITEM in $(TESTBINS); do \
		./bin/$$ITEM; \
	done
endif

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/libhighwayhash0/usr/lib/$(MULTIARCH)
	rename 's/.so/.so.0/' debian/tmp/usr/lib/$(MULTIARCH)/*.so
	install -m0755 debian/tmp/usr/lib/$(MULTIARCH)/*.so.0 \
		debian/libhighwayhash0/usr/lib/$(MULTIARCH)/
	mkdir -p debian/libhighwayhash-dev/usr/lib/$(MULTIARCH)
	install -m0755 debian/tmp/usr/lib/$(MULTIARCH)/*.a \
		debian/libhighwayhash-dev/usr/lib/$(MULTIARCH)/
	set -e; cd debian/libhighwayhash-dev/usr/lib/$(MULTIARCH)/; \
		ln -s libhighwayhash.so.0 libhighwayhash.so

## highwayhash 0~git20200803.9490b14

=== debian/changelog ===
highwayhash (0~git20200803.9490b14-4.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:25:22 +0000

highwayhash (0~git20200803.9490b14-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062341

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 10:37:34 +0000

highwayhash (0~git20200803.9490b14-4) unstable; urgency=medium

  * Orphan this package. (See #1013208)
  * Change maintainer to QA group.
  * Bump Standards-Version to 4.6.2.

 -- Mo Zhou <lumin@debian.org>  Sun, 10 Dec 2023 16:46:41 -0500

highwayhash (0~git20200803.9490b14-3) unstable; urgency=medium

  * Give up tracking C++ symbols. (Closes: #984175)
  * Fix FTCBFS due to multiple reasons; Patch rebased. (Closes: #970832)
  * Bump Standards-Version to 4.6.0 (no change).
  * Strip unnecessary shlibs:Depends from -dev package.
  * Remove unused lintian overrides.

 -- Mo Zhou <lumin@debian.org>  Wed, 24 Nov 2021 16:28:14 -0500

highwayhash (0~git20200803.9490b14-2) unstable; urgency=medium

  [ Yangfl ]
  * Fix FTBFS on most archs due to problematic Makefile. (Closes: #986273)

  [ Mo Zhou ]
  * Rename libhighwayhash0.symbols -> lib{...}.symbols.amd64.

 -- Mo Zhou <lumin@debian.org>  Mon, 05 Apr 2021 10:52:10 +0800

highwayhash (0~git20200803.9490b14-1) unstable; urgency=medium

  * New upstream version 0~git20200803.9490b14
  * Fixup architecture detection.
  * Deprecate d/compat and bump debhelper compat level to 13.
  * Update my mail address in control and copyright.
  * Specify Rules-Requires-Root: no
  * Fixup installation part in d/rules.
  * Refresh symbols control file for amd64, arm64, ppc64el.

 -- Mo Zhou <lumin@debian.org>  Tue, 22 Sep 2020 10:50:25 +0800

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: highwayhash
 Section: science
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Mo Zhou <cdluminate@gmail.com>
-Build-Depends: debhelper (>= 11), rename
-Standards-Version: 4.2.0
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian QA Group <packages@qa.debian.org>
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), rename
+Standards-Version: 4.6.2
 Homepage: https://github.com/google/highwayhash
 Vcs-Git: https://salsa.debian.org/science-team/highwayhash.git
-vcs-Browser: https://salsa.debian.org/science-team/highwayhash
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/science-team/highwayhash
 
 Package: libhighwayhash-dev
 Section: libdevel
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends},
-         libhighwayhash0 (= ${binary:Version})
+Depends: ${misc:Depends}, libhighwayhash0t64 (= ${binary:Version})
+Multi-Arch: same
 Description: Fast strong hash functions: SipHash/HighwayHash (development)
  Highwayhash provides three 'strong' (well-distributed and unpredictable)
  hash functions: a faster version of SipHash, a data-parallel variant of
@@ -33,7 +34,10 @@
  .
  This package ships the static library and development files.
 
-Package: libhighwayhash0
+Package: libhighwayhash0t64
+Provides: ${t64:Provides}
+Replaces: libhighwayhash0
+Breaks: libhighwayhash0 (<< ${source:Version})
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/dpkg/architecture.mk
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DESTDIR=/usr
export LIBDIR=$(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)/
export INCDIR=$(DESTDIR)/include/
TESTBINS = highwayhash_test nanobenchmark_example profiler_example sip_hash_test vector_test

ifneq (,$(filter $(DEB_BUILD_ARCH),amd64))
export HH_X64=1
endif
ifneq (,$(filter $(DEB_BUILD_ARCH),x32))
export HH_X64=1
endif
ifneq (,$(filter $(DEB_BUILD_ARCH),arm64))
export HH_AARCH64=1
endif
ifneq (,$(filter $(DEB_BUILD_ARCH),ppc64el ppc64))
export HH_POWER=1
endif

%:
	dh $@

override_dh_auto_clean:
	dh_auto_clean
	-$(RM) deps.mk

override_dh_auto_build:
	dh_auto_build -- all lib/libhighwayhash.so

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test
	for ITEM in $(TESTBINS); do \
		./bin/$$ITEM; \
	done
endif

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/libhighwayhash0t64/usr/lib/$(DEB_HOST_MULTIARCH)
	rename 's/.so/.so.0/' debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.so
	install -m0755 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.so.0 \
		debian/libhighwayhash0t64/usr/lib/$(DEB_HOST_MULTIARCH)/
	mkdir -p debian/libhighwayhash-dev/usr/lib/$(DEB_HOST_MULTIARCH)
	install -m0755 debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.a \
		debian/libhighwayhash-dev/usr/lib/$(DEB_HOST_MULTIARCH)/
	set -e; cd debian/libhighwayhash-dev/usr/lib/$(DEB_HOST_MULTIARCH)/; \
		ln -s libhighwayhash.so.0 libhighwayhash.so

=== debian/tests/control ===
Tests: test.sanity
Depends: @, build-essential

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=0~git%cd.%h" \
https://github.com/google/highwayhash \
HEAD debian uupdate
